<?php

namespace Makecommerce\Ecommerce\Block\Form;

class Makecommerce extends \Magento\Payment\Block\Form
{
    // @codingStandardsIgnoreStart
    /**
     * @var string
     */
    protected $_template = 'Makecommerce_Ecommerce::form/makecommerce.phtml';

    /**
     * Payment config model
     *
     * @var \Makecommerce\Ecommerce\Config
     */
    protected $config;

    /**
     * @var \Makecommerce\Ecommerce\Model\MakecommerceConfigProvider
     */
    protected $configProvider;

    /**
     * Makecommerce constructor.
     * @param \Magento\Framework\View\Element\Template\Context $context
     * @param \Makecommerce\Ecommerce\Config $config
     * @param \Makecommerce\Ecommerce\Model\MakecommerceConfigProvider $configProvider
     * @param array $data
     */
    public function __construct(
        \Magento\Framework\View\Element\Template\Context $context,
        \Makecommerce\Ecommerce\Config $config,
        \Makecommerce\Ecommerce\Model\MakecommerceConfigProvider $configProvider,
        array $data = []
    ) {
        parent::__construct($context, $data);
        $this->config = $config;
        $this->configProvider = $configProvider;
        $this->config = $configProvider->getConfig();
        $this->config = array_key_exists('mk', $this->config) ? $this->config['mk'] : null;
        $this->setTemplate('form/mk.phtml');
    }

    /**
     * Retrieve mk banklinks
     *
     * @return array
     */
    public function getBankLinks()
    {
        return $this->config['paymentMethods']['banklinks'];
    }

    /**
     * Get the UI mode
     *
     * @return string
     */
    public function getUiMode()
    {
        return $this->config['ui']['mode'];
    }

    /**
     * Check if countries are grouped
     *
     * @return bool
     */
    public function areCountriesGrouped()
    {
        return $this->config['ui']['groupBanklinks'];
    }

    /**
     * Check if countries are grouped
     *
     * @return bool
     */
    public function areCardsGrouped()
    {
        return $this->config['ui']['widgetGroupcc'];
    }

    /**
     * Get credit cards
     *
     * @return mixed
     */
    public function getCreditCards()
    {
        return $this->config['paymentMethods']['cards'];
    }

    /**
     * Get payment method code
     *
     * @return string
     */
    public function getMethodCode()
    {
        return \Makecommerce\Ecommerce\Model\Makecommerce::PAYMENT_METHOD_CODE;
    }

    /**
     * Get countries
     *
     * @return mixed
     */
    public function getCountries()
    {
        return $this->config['countries'];
    }

    /**
     * Get default country
     *
     * @return string
     */
    public function getDefaultCountry()
    {
        return 'ee';
    }

    /**
     * Render block HTML
     *
     * @return string
     */
    protected function _toHtml()
    {
        $this->_eventManager->dispatch('mk_form_block_to_html_before', ['block' => $this]);
        return parent::_toHtml();
    }
    // @codingStandardsIgnoreEnd
}
